#! /bin/sh -e

. /etc/init.d/functions.sh
trap 'end $?' EXIT

start_respawnd() {
if [ ! "$(pidof respawnd)" ]; then
respawnhandler=/etc/init.d/respawnd
[ ! -x "$respawnhandler" ] || $respawnhandler start || warning "Failed to start acap restarter"
fi
}

sdkkillall() {
local appname pid thispid binexe

[ "$1" ] && [ "$2" ] || return 2
appname=${2##*/}
pid=$(pidof $appname) || return 0
if [ "$pid" ]; then
for thispid in $pid ; do
binexe=$(readlink /proc/${thispid}/exe) || return 1
if eval $(echo -n "$binexe" | grep -q "$INSTALLDIR" ) ; then
[ "$1" = 0 ] ||
logger -p INFO -t angelcamconnector[0] "/usr/sbin/install-package.sh: kill -$1 $thispid" || :
kill -$1 $thispid || return 1
fi
done
fi
}


start_d() {
elflibcheck.sh /usr/local/packages/angelcamconnector/angelcamconnector || {
logger -p INFO -t angelcamconnector[0] "elflibcheck failed angelcamconnector"
return 1
}


start-package-allowed.sh /usr/local/packages/angelcamconnector/angelcamconnector > /dev/null 2>&1 || {
return 1
}
logger -p INFO -t angelcamconnector[0] "starting angelcamconnector"
/sbin/start-stop-daemon --start --background -c sdk:sdk --exec "/usr/local/packages/angelcamconnector/angelcamconnector" -- arr-rs.angelcam.com:8900 -c /usr/share/ca-certificates -c /usr/local/packages/angelcamconnector/ca.pem  -r 'rtsp://root:pass@localhost/axis-media/media.amp' --conn-state-file=/usr/local/packages/angelcamconnector/localdata/state --config-file=/usr/local/packages/angelcamconnector-storage/config.json || {
  logger -p INFO -t angelcamconnector[0] "start-stop-daemon \"/usr/local/packages/angelcamconnector/angelcamconnector\"  exec failed!" || {
  return 1
  }
}

#update uuid info
cp /usr/local/packages/angelcamconnector-storage/config.json /usr/local/packages/angelcamconnector/html/arrowconfig.json 2>&1 >/dev/null
if [ $? != "0" ]; then
  return 1;
fi

} #end_start_d


stop_d() {
logger -p INFO -t angelcamconnector[0] "stopping angelcamconnector"
stop_daemon /usr/local/packages/angelcamconnector/angelcamconnector ||
logger -p INFO -t angelcamconnector[0] "stop_daemon angelcamconnector failed"

! sdkkillall 0 /usr/local/packages/angelcamconnector/angelcamconnector ||
sdkkillall SIGKILL /usr/local/packages/angelcamconnector/angelcamconnector || :
}

read_enabled() {
local IFS==

[ -r /usr/local/packages/angelcamconnector/conf/runstate.conf ] || return 0
while read var val; do
case $var in
ENABLED)
eval ENABLED=$val
;;
*)
logger -p INFO -t angelcamconnector[0] "Runstate variable $var unknown."
;;
esac
done < /usr/local/packages/angelcamconnector/conf/runstate.conf
}

case $1 in
start)
read_enabled
if [ "$ENABLED" = no ]; then
information "Skipping start of angelcamconnector (angelcamconnector disabled)."
return 0
fi
begin "Starting angelcamconnector"
start_d
;;
stop)
begin "Stopping angelcamconnector"
stop_d
;;
restart)
begin "Restarting angelcamconnector"
stop_d ; start_d
;;
*)
error "Usage: $0 start|stop|restart"
;;
esac

